function useImage(details, netstutas, loadlmageOnlyWifiSwitch) {
  const previewLen = ref(0)
  const imageLoadedLen = ref(0)

  const imageLoaded = ref(false)

  let clickFunList = []

  watch(() => imageLoadedLen.value, (val) => {
    if (val === document.querySelectorAll('#newsContent img[data-src]').length && val > 0) {
      imageLoaded.value = true
    }
  }, { deep: true })

  const loadImageSrc = (src, hasPreview, record) => {
    record.setAttribute('src', src)
    record.onload = function () {
      if (record.complete) {
        if (imageLoadedLen.value !== document.querySelectorAll('#newsContent img[data-src]').length) {
          imageLoadedLen.value += 1
        }

        if (hasPreview) {
          record.parentNode.setAttribute('status', 'success')
          record.parentNode.classList.remove('error')
          record.parentNode.classList.remove('minHeight')
          record.parentNode.classList.remove('loading')
          record.parentNode.classList.remove('no-network')
          record.parentNode.classList.add('success')
          record.classList.add('preview-image-loaded')
        }

        changeContentHtmlHeight({ type: '图片' })
      }

      setTimeout(() => {
        changeContentHtmlHeight({ type: '图片' })
      })
    }
    record.onerror = function () {
      if (imageLoadedLen.value !== document.querySelectorAll('#newsContent img[data-src]').length) {
        imageLoadedLen.value += 1
      }


      if (hasPreview) {
        record.parentNode.setAttribute('status', 'error')
        record.parentNode.classList.remove('success')
        record.parentNode.classList.remove('loading')
        record.parentNode.classList.remove('no-network')
        record.parentNode.classList.add('error')
      }

      changeContentHtmlHeight({ type: '图片' })
    }

    setTimeout(() => {
      changeContentHtmlHeight({ type: '图片' })
    })
  }

  const initImage = (netWorkStatus, loadImage) => {
    const list = document.querySelectorAll('#newsContent img[data-src]')

    for (let i = 0; i < list.length; i++) {
      const hasPreview = list[i].classList.contains('image-player')
      const record = list[i]
      const areadySrc = record.getAttribute('src')
      const src = record.getAttribute('data-src')
      const status = hasPreview ? record.parentNode.getAttribute('status') : record.getAttribute('status')
      // 防止重复加载
      if (areadySrc) {
        continue
      }
      // 防止重复加载
      if (status === 'success') {
        continue
      }
      // 没有该属性代表不加载
      if (!src) {
        if (imageLoadedLen.value !== document.querySelectorAll('#newsContent img[data-src]').length) {
          imageLoadedLen.value += 1
        }

        if (hasPreview) {
          record.parentNode.setAttribute('status', 'error')
          record.parentNode.classList.remove('success')
          record.parentNode.classList.remove('loading')
          record.parentNode.classList.remove('no-network')
          record.parentNode.classList.add('error')
        }
        continue
      }
      const networkStatus = [ 2, 3, 4, 5 ]
      if (!hasPreview || netWorkStatus == 1 || loadImage == '2') {
        if (status === 'loading') {
          loadImageSrc(src, hasPreview, record)
        }
      } else if (networkStatus.includes(netWorkStatus)) {
        if (status === 'loading' && record.parentNode.classList.contains('error')) {
          if (hasPreview) {
            record.parentNode.classList.remove('success')
            record.parentNode.classList.remove('error')
            record.parentNode.classList.add('loading')
            record.parentNode.classList.add('no-network')
          }
        }
      } else if (netWorkStatus == 0) {
        if (status === 'loading') {
          if (hasPreview) {
            record.parentNode.classList.remove('success')
            record.parentNode.classList.remove('error')
            record.parentNode.classList.remove('no-network')
            record.parentNode.classList.add('error')
          }
        }
      }
    }
  }

  const remove = () => {
    const previewElList = document.querySelectorAll('#newsContent .preview-image-block')
    for (let i = 0; i < previewElList.length; i++) {
      previewElList[i].removeEventListener('click', clickFunList[i])
    }
    previewLen.value = 0
    imageLoadedLen.value = 0
    imageLoaded.value = false
    clickFunList = []
  }

  const addPreview = () => {
    previewLen.value += 1
  }

  // 监听客户端网络状况以及是否点过继续状态 0 无网络 1 wifi 2，3，4，5 无wifi状态
  watch([ () => netstutas.value, () => previewLen.value, () => loadlmageOnlyWifiSwitch.value ], ([ status, num, loadImage ]) => {
    if (num <= document.querySelectorAll('#newsContent img[data-src]').length && loadImage != '0' && status != -1) {
      initImage(status, loadImage)
    }
  }, { deep: true })

  const startImage = () => {
    const previewElList = document.querySelectorAll('#newsContent .preview-image-block')
    const imageArraryEl = document.querySelectorAll('#newsContent .preview-image-block img.image-player')
    for (let i = 0; i < previewElList.length; i++) {
      function clickFun() {
        if (hasClass(previewElList[i], 'link-image')) {
          const peopleOrigin = []
          let url = previewElList[i].getAttribute('data-href')
          if (peopleOrigin.some(origin => url.includes(origin))) {
            if (!url.includes('isIner=0')) {
              if (url.includes('?')) {
                if (url[url.length - 1] !== '?') {
                  url = `${url}&isIner=0`
                } else if (url[url.length - 1] === '?') {
                  url = `${url}isIner=0`
                }
              } else {
                url = `${url}?isIner=0`
              }
            }
          }

          let dataInfo = previewElList[i].getAttribute('data-rmrbnative')

          try {
            if (dataInfo) {
              dataInfo = Base64().decode(dataInfo)
              dataInfo = JSON.parse(dataInfo)
            }
          } catch (error) {
            dataInfo = undefined
          }

          try {
            let inner = dataInfo &&
              (typeof dataInfo === 'undefined'
                ? 'undefined'
                : typeof dataInfo === 'object' && dataInfo.jumpType && dataInfo.jumpType == 'internal')

            if (!inner) {
              // TODO 这里判断第二种方法：url地址规则判断是否端内打开
            }
            if (inner && url) {
              jumpAppInnerFun(dataInfo, url)
            } else if (url) {
              sendNative(
                'jsCall_appInnerLinkMethod',
                {
                  appInnerLink: `rmrbapp://rmrb.app/openwith?type=h5&url=${encodeURIComponent(url)}&skipType=4`
                }
              )
            }
          } catch (e) {
            console.log(e)
          }
        }

        if (
          hasClass(previewElList[i].querySelector('.image-player'), 'preview-image-loaded') ||
          hasClass(previewElList[i], 'no-network') ||
          hasClass(previewElList[i], 'link-image')
        ) {
          try {
            if (hasClass(previewElList[i], 'no-network')) {
              const record = previewElList[i]
              const status = record.getAttribute('status')

              if (status === 'loading') {
                record.classList.remove('no-network')
                const imageEl = imageArraryEl[i]
                const src = imageEl.getAttribute('data-src')
                loadImageSrc(src, true, imageEl)
              }
              return
            }

            if (hasClass(previewElList[i], 'link-image')) { return }

            let imageArrary = []
            for (let a = 0; a < imageArraryEl.length; a++) {
              const src = imageArraryEl[a].getAttribute('data-origin-src') || imageArraryEl[a].getAttribute('src')
              const newSrc = src.split('?')[0]
              const originRecord = details.value.photoList.find(el => el.picPath === newSrc)
              const status = previewElList[a].getAttribute('status')
              const params = {
                pic: src,
                width: originRecord ? originRecord.width : previewElList[a].getBoundingClientRect()
                  ? previewElList[a].getBoundingClientRect().width || 0
                  : 0,
                height: originRecord ? originRecord.height : previewElList[a].getBoundingClientRect()
                  ? previewElList[a].getBoundingClientRect().height || 0
                  : 0
              }

              if (status === 'success') imageArrary.push(params)
            }

            imageArrary = imageArrary.map(el => {
              if (!el.width) {
                el.width = previewElList[i].getBoundingClientRect().width
              }
              if (!el.height) {
                el.height = previewElList[i].getBoundingClientRect().height
              }
              return el
            })

            const params = {
              imgIndex: i,
              imgArr: deepCopy(imageArrary)
            }

            if (window.config.VUE_BASE_NODE === 'dev') {
              console.log(params)
            }

            sendNative(
              'jsCall_receiveH5Data',
              {
                dataSource: '3',
                dataJson: '',
                imgListData: JSON.stringify(params)
              }
            )
          } catch (e) {
          }
        }
      }
      previewElList[i].addEventListener('click', clickFun)
      clickFunList.push(clickFun)
    }
  }

  return {
    remove,
    addPreview,
    initImage,
    startImage,
    imageLoaded
  }
}
