function useSwiper() {
  const elList = ref([])

  const addSwiper = (record) => {
    elList.value.push(record)
  }

  const remove = () => {
    elList.value = []
  }

  const startSwiper = () => {
    loadFile(document,
      {
        src: './js/plugin/swiper-bundle.min.js',
        tag: 'script',
        type: 'text/javascript',
        defer: 'defer'
      }, () => {
        elList.value.forEach(el => {
          new Swiper(el.id, {
            navigation: {},
            pagination: {
              el: '.swiper-pagination'
            },
            autoplay: {
              delay: el.time * 1000,
              disableOnInteraction: false
            },
            loop: el.isLoop,
            on: {
              slideChange: function (val) {
                if (val.realIndex === el.length - 1) {
                  if (el.isLoop) {
                    return
                  } else {
                    this.autoplay.stop()
                  }
                } else {
                  if (!el.isLoop) {
                    this.autoplay.start()
                  }
                }
              }
            }
          })
        })
      }
    )
  }

  return {
    elList,
    remove,
    addSwiper,
    startSwiper
  }
}
