function playerVideo(player, events) {
  if (!player.options.isGiveWidth) {
    if (hasClass(player.template.$container.parentNode, 'init')) { return }
  }
  player.callBackFun.play()
  // 上报
  /* 视频的宽度 */
  //在useVideo文件中
  const videoOptions = player.options.videoOptions
  // const originWidth = videoOptions.originWidth
  /* 视频的高度 */
  // const originHeight = videoOptions.originHeight
  const width = videoOptions.width
  const height = videoOptions.height
  const top = player.container.parentNode.offsetTop
  const left = player.container.parentNode.getBoundingClientRect().left
  const videoLandscape = width > height ? '1' : (width < height ? '2' : '')
  const videoUrl = player.options.record.url

  if (window.config.VUE_BASE_NODE === 'dev') {
    console.log('视频播放', width, height, left, top, videoLandscape)
  }


  try {
    sendNative(
      'jsCall_currentPageOperate',
      {
        operateType: '9',
        positionLeft: `${left}`,
        positionTop: `${top}`,
        positionWidth: `${width}`,
        positionHeight: `${height}`,
        videoLandscape: `${videoLandscape}`,
        videoUrl: `${videoUrl}`
      },
      res => {
      }
    )
  } catch (e) {}
}

function clickPoster(player, events) {
  events.proxy(player.template.$cover, 'click', (e) => {
    e.stopImmediatePropagation()
    e.stopPropagation()

    playerVideo(player, events)
  })
}

function clickContainer(player, events) {
  if (player.player) {
    events.proxy(player.template.$video, 'click', (e) => {
      if (events.dragFixed) {
        player.player.pause()
        events.layerDom.toggleCommonLayer(player.template.$miniLayer, true)
      } else {
        if (player.player.getStatus() === 'playing' || player.player.getStatus() === 'pause') {
          events.clearSetTimeOut()
          if (hasClass(player.template.$container.parentNode, 'init')) { return }
          if (hasClass(player.template.$bottom, 'none')) {
            events.layerDom.tooglePlayerBottom(true)
            events.layerDom.tooglePlayerBottom(false, true)
          } else {
            events.layerDom.tooglePlayerBottom(false)
          }
        }
      }
    })
  }
}

function clickErrorBlock(player, events) {
  events.proxy(player.template.$error, 'click', (e) => {
    e.stopImmediatePropagation()
    e.stopPropagation()
  })
}

function clickErrorBtn(player, events) {
  events.proxy(player.template.$errorBtn, 'click', (e) => {
    e.stopImmediatePropagation()
    e.stopPropagation()
  })
}

function clickNetworkBlock(player, events) {
  events.proxy(player.template.$network, 'click', (e) => {
    e.stopImmediatePropagation()
    e.stopPropagation()
  })
}

function clickNetworkBlockBtn(player, events) {
  events.proxy(player.template.$networkBtn, 'click', (e) => {
    e.stopImmediatePropagation()
    e.stopPropagation()

    if (!events.dragFixed) {
      if (hasClass(player.template.$container.parentNode, 'init')) { return }

      events.clearSetTimeOut()
      player.callBackFun.continueNetwork()
      if (window.config.VUE_BASE_NODE === 'dev') {
        playerVideo(player, events)
      } else {
        playerVideo(player, events)
        try {
          sendNative('jsCall_currentPageOperate', {
            operateType: '4'
          })
        } catch (e) { }
      }
    }
  })
}

function clickLayerStateBlock(player, events) {
  events.proxy(player.template.$layerState, 'click', (e) => {
    e.stopImmediatePropagation()
    e.stopPropagation()

    playerVideo(player, events)
  })
}

function clickLayerStateBtn(player, events) {
}

function clickBottomState(player, events) {
  if (player.player) {
    events.proxy(player.template.$bottomState, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (player.player) {

        if (!events.dragFixed) {
          events.clearSetTimeOut()
          events.layerDom.tooglePlayerBottom(true)
          if (player.player.getStatus() === 'playing') {
            player.player.pause()
            player.template.$bottomState.setAttribute('src', './image/player/video_puse.svg')
          } else {
            player.player.play()
            player.template.$bottomState.setAttribute('src', './image/player/video_play.svg')
          }
          events.layerDom.tooglePlayerBottom(false, true)
        }
      }
    })
  }
}

function clickBottonFullScreen(player, events) {
  if (player.player) {
    events.proxy(player.template.$bottomFullScreen, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (!events.dragFixed) {
        events.layerDom.tooglePlayerBottom(true)
        events.clearSetTimeOut()

        if (player.player.fullscreenService.getIsFullScreen()) {
          player.player.fullscreenService.cancelFullScreen()
        } else {
          player.player.fullscreenService.requestFullScreen()
        }

        events.layerDom.tooglePlayerBottom(false, true)
      }
    })
  }
}

function clickReplayBlock(player, events) {
  if (player.player) {
    events.proxy(player.template.$replay, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()
    })
  }
}

function clickReplayBtn(player, events) {
  if (player.player) {
    events.proxy(player.template.$replayBtn, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (!events.dragFixed) {
        events.clearSetTimeOut()
        player.template.$video.currentTime = 0
        player.template.$video.play()

        player.events.playerEnd = false

        events.layerDom.toggleCommonLayer(player.template.$replay, false)

        events.layerDom.toggleBottomPlayState(true)

        events.layerDom.tooglePlayerBottom(true)

        events.layerDom.tooglePlayerBottom(false, true)
      }
    })
  }
}

function clickMiniLayerBlcok(player, events) {
  if (player.player) {
    events.proxy(player.template.$miniLayer, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (player.player.getStatus() === 'pause') {
        player.player.play()
        events.layerDom.toggleCommonLayer(player.template.$miniLayer, false)
      } else if (player.player.getStatus() === 'playing') {
        player.player.pause()
        events.layerDom.toggleCommonLayer(player.template.$miniLayer, true)
      }
    })
  }
}

function clickMiniLayerBtn(player, events) {
  if (player.player) {
    events.proxy(player.template.$miniLayerBtn, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      player.player.play()

      events.layerDom.toggleCommonLayer(player.template.$miniLayer, false)
    })
  }
}

function clickMiniCloseBtn(player, events) {
  if (player.player) {
    events.proxy(player.template.$miniClose, 'click', (e) => {
      e.stopImmediatePropagation()
      e.stopPropagation()

      if (events.dragFixed) {
        player.callBackFun.closeFixModal()
      }
    })
  }
}
