function createLayerState() {
  const isDark = document.querySelector('html').getAttribute('dark-mode') === 'true'
  return `<div class="player-layer-state none"><div class="player-state-icon"><img class="player-state-image" src="./image/${isDark ? 'video' : 'video'}/videoPlay.svg" alt=""></div></div>`
}

function createPlayerBottom() {
  return `<div class="player-bottom animate__animated none"><img class="player-state" src="./image/player/video_puse.svg" alt=""><div class="center-box"><span class="player-current droidSerif-bold">00:00</span><div class="player-progress-block"><div class="player-progress"><div class="player-buffer"></div><div class="player-loaded"><div class="player-loaded-drag"><i></i></div></div><div class="player-preload"></div></div></div><span class="player-duration droidSerif-bold">00:00</span></div><img class="player-full-screen" src="./image/player/fullScreen.svg" alt=""></div>`
}

function createPlayerNetwork() {
  return `<div class="player-network none"><div class="player-network-block" ><div class="network-title droidSerif-bold">正在使用非Wi-Fi网络,播放将产生流量费用</div><div class="btn droidSerif-bold">使用流量播放</div></div></div>`
}

function createPlayerPoster() {
  const isDark = document.querySelector('html').getAttribute('dark-mode') === 'true'
  return `<div class="player-cover" style="background: ${isDark ? '#333' : ''}"><img src="" alt=""><div class="player-state-icon"><img class="player-state-image" src="./image/video/videoPlay.svg" alt=""></div></div>`
}

function createPlayerError() {
  return `<div class="player-error none">></div>`
}

function createPlayerLoading() {
  return `<div class="player-loading none"><svg xmlns="http://www.w3.org/2000/svg" width="50px" height="50px" viewBox="0 0 100 100" preserveAspectRatio="xMidYMid" class="uil-default"><rect x="0" y="0" width="100" height="100" fill="none" class="bk"></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(0 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-1s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(30 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.9166666666666666s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(60 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.8333333333333334s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(90 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.75s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(120 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.6666666666666666s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(150 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.5833333333333334s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(180 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.5s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(210 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.4166666666666667s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(240 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.3333333333333333s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(270 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.25s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(300 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.16666666666666666s" repeatCount="indefinite"></animate></rect><rect x="47" y="40" width="6" height="20" rx="5" ry="5" fill="#ffffff" transform="rotate(330 50 50) translate(0 -30)"><animate attributeName="opacity" from="1" to="0" dur="1s" begin="-0.08333333333333333s" repeatCount="indefinite"></animate></rect></svg></div>`
}

function createMiniProgress() {
  return `<div class="player-mini-progress none"><div class="player-mini-loaded"></div><div class="player-mini-buffer"></div></div>`
}

function createPlayerBg() {
  return `<div class="player-state-bg"></div>`
}

function createReplay() {
  return `<div class="player-replay none"><span class="droidSerif-bold">Replay</span></div>`
}

function createMiniLayer() {
  return `<div class="player-mini-layer none"><img src="" alt=""></div>`
}

function createMiniClose() {
  return `<div class="player-mini-close none"><img class="close" src="" alt=""></div>`
}
