function query(selector, parent = document) {
  return parent.querySelector(selector)
}

function addClass(target, className) {
  return target.classList.add(className)
}

function removeClass(target, className) {
  return target.classList.remove(className)
}

function hasClass(target, className) {
  return target.classList.contains(className)
}

function toggleClass({
  target,
  stateType,
  stateClassNames,
  isDirect
}) {
  const classNameToogleObj = {
    add: 'none',
    remove: 'none'
  }
  // 注意 isDirect = true， stateType 取相反直接做删除或者增加class； isDirect = false add、remove为展示或者消失
  const state = isDirect ? stateType === 'add' ? 'remove' : 'add' : stateType
  if (state === 'add') {
    removeClass(target, stateClassNames ? stateClassNames[stateType] : classNameToogleObj[stateType])
  } else {
    addClass(target, stateClassNames ? stateClassNames[stateType] : classNameToogleObj[stateType])
  }
}

function timeRangeToArray(timeRanges) {
  let ranges = []

  for (let i = 0; i < timeRanges.length; ++i)
    ranges = customConcat(ranges, [timeRanges.start(i), timeRanges.end(i)])

  return ranges
}
