/* app主动调用通知h5事件 */

/*用于在 WebView 中建立与 JavaScript 的桥接通信 原生应用程序与 WebView 中运行的 JavaScript 之间进行交互 */
function setupWebViewJavascriptBridge(callback) {
  if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge) }
  /* WVJBCallbacks：提供一个容器，以便在桥接建立之前暂存回调函数，并在桥接建立后依次触发执行 */
  if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback) }
  window.WVJBCallbacks = [ callback ]
  var WVJBIframe = document.createElement('iframe')
  WVJBIframe.style.display = 'none'
  WVJBIframe.src = 'https://__bridge_loaded__'
  document.documentElement.appendChild(WVJBIframe)
  setTimeout(function () { document.documentElement.removeChild(WVJBIframe) }, 0)
}

function connectWebViewJavascriptBridge(callback) {
  /*WebViewJavascriptBridge.inited： 表示 WebViewJavascriptBridge（WebView JavaScript 桥接对象）是否已初始化或是否已经建立了与原生应用程序的桥接连接 */
  if (window.WebViewJavascriptBridge && WebViewJavascriptBridge.inited) {
    callback(WebViewJavascriptBridge)
  } else {
    document.addEventListener(
      'WebViewJavascriptBridgeReady'
      , function () {
        callback(WebViewJavascriptBridge)
      },
      false
    )
  }
}

function sendNative(name, data, callback) {
  if (!window.WebViewJavascriptBridge) return
  if (judgTerminal() === 1) {
    try {
      window.WebViewJavascriptBridge.callHandler(name, data, function (responseData) {
        if (callback) callback(responseData)
      })
    } catch (e) {

    }
  } else {
    try {
      window.WebViewJavascriptBridge.callHandler(name, data, function (response) {
        if (callback) callback(response)
      })
    } catch (e) {

    }
  }
}

function connetAppLogin() {
  if (judgTerminal() === 1) {
    /*bridge： WebViewJavascriptBridge */
    connectWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_appNotifyEvent', function (data, responseCallback) {
        const objData = typeof data === 'object' ? data : JSON.parse(data)
        if (objData && (objData.event == '13')) {
          if (pageLoadOutTime || hasDetails) {
            return
          }

          errorStatus = false
          document.querySelector('.error-block').style.display = 'none'
          darkMode = objData.darkMode || darkMode
          window.config.VUE_STATE = {
            key: 'darkMode',
            value: darkMode
          }
          if (document.querySelector('#state-change')) {
            document.querySelector('#state-change').click()
          }
          document
          .querySelector('html')
          .setAttribute('dark-mode', darkMode === 'dark')
          firstTime = new Date()
          pageLoadOutTime = null
          clearTimeout(pageLoadOutTime)
          hasDetails = false
          checkPageLoadingTimeOut()

          setRemUnit()
          setBodyFontSize()
        }
        window.config.VUE_APP_LOGIN = data
        if (document.querySelector('#page-change')) {
          document.querySelector('#page-change').click()
        }
        if (document.querySelector('#notice-change')) {
          window.config.MEDIAPLAY = data
          document.querySelector('#notice-change').click()
        }
        if (document.querySelector('#quitevent-change')) {
          document.querySelector('#quitevent-change').click()
        }
        if (document.querySelector('#page-reload-change')) {
          window.config.PAGERELOAD = data
          document.querySelector('#page-reload-change').click()
        }
        if (document.querySelector('#appFontSize-change')) {
          window.config.APP_FONT_SIZE = data
          document.querySelector('#appFontSize-change').click()
        }
        if (document.querySelector('#darkMode-change')) {
          window.config.DARK_MODE = data
          document.querySelector('#darkMode-change').click()
        }
        if (responseCallback) responseCallback(data)
      })
    })
  } else {
    setupWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_appNotifyEvent', function (data, responseCallback) {
        const objData = typeof data === 'object' ? data : JSON.parse(data)
        if (objData && (objData.event == '13')) {
          if (pageLoadOutTime || hasDetails) {
            return
          }

          errorStatus = false
          document.querySelector('.error-block').style.display = 'none'
          darkMode = objData.darkMode || darkMode
          window.config.VUE_STATE = {
            key: 'darkMode',
            value: darkMode
          }
          if (document.querySelector('#state-change')) {
            document.querySelector('#state-change').click()
          }
          document
          .querySelector('html')
          .setAttribute('dark-mode', darkMode === 'dark')
          firstTime = new Date()
          pageLoadOutTime = null
          hasDetails = false
          checkPageLoadingTimeOut()

          setRemUnit()
          setBodyFontSize()
        }
        window.config.VUE_APP_LOGIN = data
        if (document.querySelector('#page-change')) {
          document.querySelector('#page-change').click()
        }
        if (document.querySelector('#notice-change')) {
          window.config.MEDIAPLAY = data
          document.querySelector('#notice-change').click()
        }
        if (document.querySelector('#quitevent-change')) {
          document.querySelector('#quitevent-change').click()
        }
        if (document.querySelector('#page-reload-change')) {
          window.config.PAGERELOAD = data
          document.querySelector('#page-reload-change').click()
        }
        if (document.querySelector('#appFontSize-change')) {
          window.config.APP_FONT_SIZE = data
          document.querySelector('#appFontSize-change').click()
        }
        if (document.querySelector('#darkMode-change')) {
          window.config.DARK_MODE = data
          document.querySelector('#darkMode-change').click()
        }
        if (responseCallback) responseCallback(data)
      })
    })
  }
}

//注册网络状态方法，让app调取
function networkStatus() {
  if (judgTerminal() === 1) {
    connectWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_appNetworkStatusChangedEvent', function (data, responseCallback) {
        window.config.VUE_APP_NETWORK = data
        if (document.querySelector('#network-change')) {
          document.querySelector('#network-change').click()
        }
        if (responseCallback) responseCallback(data)
      })
    })
  } else {
    setupWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_appNetworkStatusChangedEvent', function (data, responseCallback) {
        window.config.VUE_APP_NETWORK = data
        if (document.querySelector('#network-change')) {
          document.querySelector('#network-change').click()
        }
        if (responseCallback) responseCallback(data)
      })
    })
  }
}

function appClearData() {
  if (judgTerminal() === 1) {
    connectWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_clearAppData', function (data, responseCallback) {
        if (document.querySelector('#clearData')) {
          document.querySelector('#clearData').click()
        }
        if (responseCallback) responseCallback(data)
      })
    })
  } else {
    setupWebViewJavascriptBridge(function (bridge) {
      bridge.registerHandler('jsCall_clearAppData', function (data, responseCallback) {
        if (document.querySelector('#clearData')) {
          document.querySelector('#clearData').click()
        }
        if (responseCallback) responseCallback(data)
      })
    })
  }
}

function mockAppRequestDetails() {
  setTimeout(() => {
    document.querySelector('#page-reload-change').click()
  }, 1000)

  setTimeout(() => {
    window.config.VUE_CONTENT_CONFIG = {
      code: '0',
      data: getArticleDetails()
    }
    if (document.querySelector('#detail-change')) {
      logInfo('appData', window.config.VUE_CONTENT_CONFIG.data)
      document.querySelector('#detail-change').click()
    }
  }, 1200)
}

function setHtmlBaseOptions(appData) {
  try {
    const data =
      typeof appData === 'object' ? appData : JSON.parse(appData)
    if (data.dataJson) {
      const dataJson =
        typeof data.dataJson === 'object'
          ? data.dataJson
          : JSON.parse(data.dataJson)
      if (data.dataExt) {
        hasAppLoginExtra = true

        const extraData = typeof data.dataExt === 'object'
          ? data.dataExt
          : JSON.parse(data.dataExt)
        const darkMode = extraData ? extraData.darkMode : ''
        window.config.VUE_STATE = {
          key: 'darkMode',
          value: darkMode
        }
        if (document.querySelector('#state-change')) {
          document.querySelector('#state-change').click()
        }
        document
        .querySelector('html')
        .setAttribute('dark-mode', darkMode == 'dark')
        const appFontSize = extraData ? extraData.fontSizes : ''
        setRemUnit(appFontSize)
      }
    }
  } catch (e) {
    console.log(e)
  }
}

/* 该方法由H5预埋，App加载完成后 app主动传递数据用。 */
document.addEventListener('DOMContentLoaded', function () {
  if (window.config.VUE_BASE_NODE === 'dev') {
    loadFile(
      document,
      {
        src: './js/mock/mock.min.js',
        tag: 'script',
        type: 'text/javascript',
        defer: 'defer'
      },
      () => {
        loadFile(
          document,
          {
            src: './js/mock/index.js',
            tag: 'script',
            type: 'text/javascript',
            defer: 'defer'
          },
          () => {
            loadFile(
              document,
              {
                src: './js/plugin/axios.min.js',
                tag: 'script',
                type: 'text/javascript',
                defer: 'defer'
              },
              () => {
                loadFile(
                  document,
                  {
                    src: './js/utils/request.js',
                    tag: 'script',
                    type: 'text/javascript',
                    defer: 'defer'
                  },
                  () => {
                    window.config.initLoad = true
                    if (window.config && window.config.devApp) {
                      mockAppRequestDetails()
                    }
                  }
                )
              }
            )
          }
        )
      }
    )

    return
  }

  try {
    if (judgTerminal() === 1) {
      connectWebViewJavascriptBridge(function (bridge) {
        bridge.registerHandler('jsCall_receiveAppData', function (appData, responseCallback) {
          window.config.VUE_CONTENT_CONFIG = appData
          setHtmlBaseOptions(appData)
          if (document.querySelector('#detail-change')) {
            document.querySelector('#detail-change').click()
          }
          if (responseCallback) responseCallback(appData)
        })
      })
    } else {
      setupWebViewJavascriptBridge(function (bridge) {
        bridge.registerHandler('jsCall_receiveAppData', function (appData, responseCallback) {
          window.config.VUE_CONTENT_CONFIG = appData
          setHtmlBaseOptions(appData)
          if (document.querySelector('#detail-change')) {
            document.querySelector('#detail-change').click()
          }
          if (responseCallback) responseCallback(appData)
        })
      })
    }
    appClearData()
    connetAppLogin()
    networkStatus()
  } catch (e) {

  }
  /* videoStatus() */
  //
  // setTimeout(() => {
  //   window.config.VUE_APP_NETWORK = 0
  //
  //   if (document.querySelector('#network-change')) {
  //     document.querySelector('#network-change').click()
  //   }
  // }, 4000)
  //
  // setTimeout(() => {
  //   window.config.VUE_APP_NETWORK = 2
  //
  //   if (document.querySelector('#network-change')) {
  //     document.querySelector('#network-change').click()
  //   }
  // }, 2000)
  // setTimeout(() => {
  //   window.config.VUE_APP_NETWORK = 0
  //
  //   if (document.querySelector('#network-change')) {
  //     document.querySelector('#network-change').click()
  //   }
  // }, 4000)
  //
  // setTimeout(() => {
  //   if (document.querySelector('#browseCnt-change')) {
  //     let data = { browseCount: '22w',event : 6 }
  //     const dataInfo = typeof data === 'object' ? JSON.stringify(data) : data
  //     document.querySelector('#browseCnt-change').setAttribute('data-info', dataInfo)
  //     document.querySelector('#browseCnt-change').click()
  //   }
  // }, 2000)
})

// setTimeout(() => {
//   setHtmlBaseOptions({
//     dataJson: {
//
//     },
//     dataExt: {
//       darkMode: 'dark'
//     }
//   })
// }, 3000)
